import time
import random
from multiprocessing.shared_memory import ShareableList


def get_or_create(name):
    try:
        return ShareableList(name=name)
    except:
        return ShareableList(sequence=[0] + [b"-"*256]*256, name=name)

def play_random_move(heights):
    o = random.choice([i for i, x in enumerate(heights, start=1) if x != 6])
    heights[o-1] += 1
    print(o)

def play_randomly(go_first):
    """Boring agent used as a fallback when we can't find a partner (me irl)"""
    heights = [0]*7
    if go_first:
        play_random_move(heights)
    while True:
        i = int(input())
        heights[i-1] += 1
        play_random_move(heights)

firsts = get_or_create("cg45_hair_firsts")
seconds = get_or_create("cg45_hair_seconds")

are_first = input() == "f"

theirs, ours = (firsts, seconds) if are_first else (seconds, firsts)

if not theirs[0]:
    channel = ShareableList([None])
    ours[1+ours[0]] = channel.shm.name
    ours[0] += 1
    for _ in range(10):
        time.sleep(0.5)
        if channel[0]:
            break
    else:
        play_randomly(are_first)
    channel[0] = None
else:
    theirs[0] -= 1
    channel = ShareableList(name=theirs[theirs[0]+1])
    channel[0] = 1
    while channel[0] is not None:
        pass

def play_move():
    while channel[0] is None:
        pass
    print(channel[0])
    channel[0] = None

if are_first:
    play_move()
while True:
    channel[0] = int(input())
    while channel[0] is not None:
        pass
    play_move()
